#INCLUDE "TOTVS.CH"
/*

 	
ͻ 	
Programa   FlgPd  Autor  Leandro Oliveira        Data   20/02/15    	
͹  
Desc.     Para Adicionar botao de recalculo usar o PE A410CONS		       							  
SetKey( VK_F8,			{ || U_EXPLKIT() } ) //Atalho dentro do PE A410CONS	
Criar a explosao de kit com o parametro de acordo com o tipo a ser explodido	
usar a funo Ma410Bom pegar somente o primeiro nivel dos itens da estrutura	
01 = Pedido nao deve ter sua data alterada                                  	
																						
͹ 	
Uso                                                                     	
ͼ 	
 	

*/

User Function EXPLKIT()

Local	lDel	:= GDDeleted (n)
Local cTipo	:=	GDFieldGet("C6_UM",n, .F. )
Local nQtVen	:=	GDFieldGet("C6_QTDVEN",n, .F. )
Local nPosX	:= n

If !lDel .AND. cTipo== "CJ" .AND. nQtVen > 0
	Processa({||Ma410Bom(aHeader,aCols,n)},"Desmenbrando Kit","Processando aguarde...", .F.)
	For nX := 1 To Len(aCols)	
		If !GDDeleted (nX)
			cTipo	:= GDFieldGet("C6_UM",nX , .F. )
			If nPosX == nX //cTipo == "CJ"
				aCOLS[nX][Len(aHeader)+1] := .T.	//Exclui o Kit Original
			EndIf
		EndIf
	Next
Else
	Do Case
		Case lDel
			MsgInfo("Item deletado","Opo invalida")
		Case cTipo<> "CJ"
			MsgInfo("Item no permitido","Opo invalida")
		Case nQtVen <= 0
			MsgInfo("Quantidade invlida","Opo invalida")
	EndCase
EndIf


Return(nil)

 Static Function Ma410Bom(aHeader,aCols,nX)

Local aArea := GetArea()
Local aBOM := {}
Local aHeadBom := {"",RetTitle("C6_PRODUTO"),RetTitle("C6_QTDVEN"),RetTitle("C6_DESCRI")}
Local nPProduto := aScan(aHeader,{|x| AllTrim(x[2]) == "C6_PRODUTO"})
Local nPTES := aScan(aHeader,{|x| AllTrim(x[2]) == "C6_TES"})
Local nPQtdVen := aScan(aHeader,{|x| AllTrim(x[2]) == "C6_QTDVEN"})
Local nPPrcVen := aScan(aHeader,{|x| AllTrim(x[2]) == "C6_PRCVEN"})
Local nPItem := aScan(aHeader,{|x| AllTrim(x[2]) == "C6_ITEM"})
Local nPTotal := aScan(aHeader,{|x| AllTrim(x[2]) == "C6_VALOR"})
Local nY := 0
Local nZ := 0
Local cItem := ""
Local lMA410BOM := ExistBlock("MA410BOM")
PRIVATE N := nX
//Ŀ
// Posiciona registros 
//
dbSelectArea("SB1")
dbSetOrder(1)
MsSeek(xFilial("SB1")+aCols[nX][nPProduto])
//Ŀ
// Verifica os produtos do primeiro nvel da estrutura 
//
dbSelectArea("SG1")
dbSetOrder(1)
MsSeek(xFilial("SG1")+aCols[nX][nPProduto])
While !Eof() .And. xFilial("SG1") == SG1->G1_FILIAL .And.;
	aCols[nX][nPProduto] == SG1->G1_COD

	dbSelectArea("SB1")
	dbSetOrder(1)
	MsSeek(xFilial("SB1")+aCols[nX][nPProduto])
	If RetFldProd(SB1->B1_COD,"B1_FANTASM") <> "S" // Projeto Implementeacao de campos MRP e FANTASM no SBZ
		aadd(aBOM,{SG1->G1_COMP,ExplEstr(aCols[nX][nPQtdVen],dDataBase,"",SB1->B1_REVATU),SB1->B1_DESC})
	EndIf
	dbSelectArea("SG1")
	dbSkip()
EndDo

ProcRegua(len(aBOM))

If lMA410BOM
	ExecBlock("MA410BOM",.F.,.F.,{aBOM})
Else
//Ŀ
// Adiciona os produtos no aCols 
//
For nX := 1 To Len(aBOM)
	IncProc("Processando...")
	cItem := aCols[Len(aCols)][nPItem]
	aadd(aCOLS,Array(Len(aHeader)+1))
	For nY	:= 1 To Len(aHeader)
		If ( AllTrim(aHeader[nY][2]) == "C6_ITEM" )
			aCols[Len(aCols)][nY] := Soma1(cItem)
		Else
			If (aHeader[nY,2] <> "C6_REC_WT") .And. (aHeader[nY,2] <> "C6_ALI_WT")
				aCols[Len(aCols)][nY] := CriaVar(aHeader[nY][2])
			EndIf
		EndIf
	Next nY
	N := Len(aCols)
	aCOLS[N][Len(aHeader)+1] := .F.
	A410Produto(aBom[nX][1],.F.)
	aCols[N][nPProduto] := aBom[nX][1]
	A410MultT("M->C6_PRODUTO",aBom[nX][1])
	If ExistTrigger("C6_PRODUTO")
		RunTrigger(2,N,Nil,,"C6_PRODUTO")
	Endif
	
	A410SegUm(.T.)
	A410MultT("M->C6_QTDVEN",aBom[nX][2])
	If ExistTrigger("C6_QTDVEN ")
		RunTrigger(2,N,Nil,,"C6_QTDVEN ")
	Endif
	If Empty(aCols[N][nPTotal]) .Or. Empty(aCols[N][nPTES])
		aCOLS[N][Len(aHeader)+1] := .T.
	EndIf
Next nX
Endif
RestArea(aArea)
Return(.T.)
 
 
 
 

